<?xml version="1.0" encoding="UTF-8"?>
<blueprint xmlns="http://www.osgi.org/xmlns/blueprint/v1.0.0"
  xmlns:ext="http://aries.apache.org/blueprint/xmlns/blueprint-ext/v1.5.0"
  xmlns:cxf="http://camel.apache.org/schema/blueprint/cxf"
  xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
  xsi:schemaLocation="
    http://www.osgi.org/xmlns/blueprint/v1.0.0 http://www.osgi.org/xmlns/blueprint/v1.0.0/blueprint.xsd
    http://camel.apache.org/schema/blueprint http://camel.apache.org/schema/blueprint/camel-blueprint.xsd
    http://camel.apache.org/schema/blueprint/cxf http://camel.apache.org/schema/blueprint/cxf/camel-cxf.xsd
  ">
  <!-- OSGI blueprint property placeholder -->
  <ext:property-placeholder evaluator="semperti">
    <!-- list some properties for this test -->
    <ext:default-properties>
      <ext:property name="ENDPOINT_ADDRESS" value="/"/>
      <ext:property name="COBIS_SERVICE_HOST" value="cobis"/>
      <ext:property name="COBIS_SERVICE_PORT" value="8181"/>
    </ext:default-properties>
  </ext:property-placeholder>

  <cxf:rsServer address="${ENDPOINT_ADDRESS}" id="serverEndpoint" serviceClass="com.semperti.hipotecario.poc.fuse.model.CobisRestService">
    <cxf:providers>
      <bean class="com.fasterxml.jackson.jaxrs.json.JacksonJsonProvider"/>
    </cxf:providers>
  </cxf:rsServer>

  <bean class="com.semperti.hipotecario.poc.fuse.api.ResponseService" id="processor"/>

  <cxf:cxfEndpoint id="psEndpoint"
    address="http://${service:COBIS}/cobis?wsdl"
    serviceClass="com.semperti.hipotecario.poc.fuse.cobis.CobisService"
    endpointName="ssp:CobisServicePort"
    serviceName="ssp:cobisService"
    wsdlURL="wsdl/cobis.wsdl"
    xmlns:ssp="http://cobis.poc.hipotecario.semperti.com/">
  </cxf:cxfEndpoint>

  <bean class="com.semperti.hipotecario.poc.fuse.util.ExceptionHandler" id="exceptionHandler"/>

  <camelContext autoStartup="true" xmlns="http://camel.apache.org/schema/blueprint">
    <onException>
      <exception>java.lang.Exception</exception>
      <handled>
        <constant>true</constant>
      </handled>
      <to uri="bean:exceptionHandler"/>
    </onException>

    <route id="mainRoute">
      <from uri="cxfrs:bean:serverEndpoint"/>
      <to uri="log:body?level=INFO"/>
      <to uri="cxf:bean:psEndpoint" />
      <recipientList>
        <simple>bean:processor?method=${header.operationName}</simple>
      </recipientList>
      <to uri="log:body?level=INFO" />
    </route>
  </camelContext>
</blueprint>
